/*
 * Tiny Vector Matrix Library
 * Dense Vector Matrix Libary of Tiny size using Expression Templates
 *
 * Copyright (C) 2001 - 2003 Olaf Petzold <opetzold@wit.regiocom.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Xpr.h,v 1.6 2003/05/17 17:28:29 opetzold Exp $
 */

#ifndef TVMET_XPR_H
#define TVMET_XPR_H

#include <tvmet/tvmet.h>
#include <tvmet/TypePromotion.h>
#include <tvmet/Functional.h>

#include <tvmet/xpr/BinOperator.h>
#include <tvmet/xpr/UnOperator.h>
#include <tvmet/xpr/Literal.h>

#include <tvmet/xpr/Vector.h>
#include <tvmet/xpr/VectorOperators.h>

#include <tvmet/xpr/Matrix.h>
#include <tvmet/xpr/MMProduct.h>
#include <tvmet/xpr/MMProductTransposed.h>
#include <tvmet/xpr/MMtProduct.h>
#include <tvmet/xpr/MtMProduct.h>
#include <tvmet/xpr/MVProduct.h>
#include <tvmet/xpr/MatrixFunctions.h>
#include <tvmet/xpr/MatrixOperators.h>

#include <tvmet/xpr/Functions.h>
#include <tvmet/xpr/ConstRef.h>			// unused
#include <tvmet/xpr/Null.h>
#include <tvmet/xpr/MatrixTranspose.h>
#include <tvmet/xpr/Eval.h>

#endif // TVMET_XPR_H

// Local Variables:
// mode:C++
// End:
