#include <iostream>
#include <cmath>

#include <tvmet/Vector.h>

using namespace std;
using namespace tvmet;

typedef Vector<double,3>	vector3d;

void reflect(vector3d& reflection, const vector3d& ray, const vector3d& surfaceNormal)
{
  // The surface normal must be unit length to use this equation.
  reflection = ray - 2 * dot(ray,surfaceNormal) * surfaceNormal;
  
  // expression printing
  cout << (ray - 2 * dot(ray,surfaceNormal) * surfaceNormal) << endl;
}

int main()
{
  vector3d x, y, z;

  // y will be the incident ray
  y[0] = 1;
  y[1] = 0;
  y[2] = -1;

  // z is the surface normal 
  z[0] = 0;
  z[1] = 0;
  z[2] = 1;
  
  reflect(x, y, z);
    
  cout << "Reflected ray is: [ " << x[0] << " " << x[1] << " " << x[2]
       << " ]" << endl;
}

/*****************************************************************************************
gcc 3.0.4 produce this code (i586):

_Z7reflectRN5tvmet6VectorIdLj3EEERKS1_S4_:
.LFB1:
	subl	$332, %esp
.LCFI0:
	movl	340(%esp), %edx
	movl	344(%esp), %eax
	movb	$0, 143(%esp)
	fldl	8(%edx)
	fldl	16(%edx)
	fxch	%st(1)
	fmull	8(%eax)
	fldl	(%edx)
	fxch	%st(2)
	fmull	16(%eax)
	fxch	%st(2)
	movl	336(%esp), %ecx
	fmull	(%eax)
	fxch	%st(1)
	faddp	%st, %st(2)
	movl	%eax, 264(%esp)
	movl	%eax, 280(%esp)
	movl	%edx, 224(%esp)
	movl	%eax, 184(%esp)
	faddp	%st, %st(1)
	movl	%edx, 192(%esp)
	movl	%eax, 208(%esp)
	movl	%edx, 288(%esp)
	movl	%eax, 304(%esp)
	fadd	%st(0), %st
	movl	%edx, 144(%esp)
	movl	%eax, 160(%esp)
	movl	%edx, 96(%esp)
	movl	%eax, 112(%esp)
	fld	%st(0)
	fstl	240(%esp)
	fstl	256(%esp)
	fstl	272(%esp)
	fstl	176(%esp)
	fstl	200(%esp)
	fstl	296(%esp)
	fstl	152(%esp)
	fstl	104(%esp)
	fxch	%st(1)
	fmull	(%eax)
	fsubrl	(%edx)
	fstpl	(%ecx)
	fstl	72(%esp)
	movl	96(%esp), %edx
	movl	112(%esp), %eax
	fld	%st(0)
	movl	%edx, 64(%esp)
	movl	%eax, 80(%esp)
	fmull	8(%eax)
	fxch	%st(1)
	fstl	40(%esp)
	fxch	%st(1)
	fsubrl	8(%edx)
	fxch	%st(1)
	movl	80(%esp), %eax
	movl	64(%esp), %edx
	fstl	8(%esp)
	fxch	%st(1)
	fstpl	8(%ecx)
	movl	%edx, 32(%esp)
	movl	%eax, 48(%esp)
	fmull	16(%eax)
	fsubrl	16(%edx)
	fstpl	16(%ecx)
	addl	$332, %esp
.LCFI1:
	ret

*****************************************************************************************/
